<?php
require 'common.inc';
$required_class = 3;
require 'secure.inc';
require 'editors.inc';

$table = 'mpdmaster';
$title = 'MPD Editor';
$key = 'MPDNumber';
$keyname = 'MPD Number';
$keytype = 'text';
$keysize = 15;
$keysize_max = 50;

$record = array();
$record["MPDSection"] = $_POST["MPDSection"];
$record["Task"] = $_POST["Task"];
$record["ApplicabilityACType"] = $_POST["ApplicabilityACType"];
$record["ApplicabilityEngineType"] = $_POST["ApplicabilityEngineType"];
$record["ManufManHours"] = $_POST["ManufManHours"];
$record["ManHours"] = $_POST["ManHours"];
$record["TaskDescription"] = $_POST["TaskDescription"];
$record["Notes"] = $_POST["Notes"];
$record["ThresholdValue"] = $_POST["ThresholdValue"];
$record["ThresholdUnits"] = $_POST["ThresholdUnits"];
$record["RepeatValue"] = $_POST["RepeatValue"];
$record["RepeatUnits"] = $_POST["RepeatUnits"];

$update = beginEditor($table, $title, $record, $rs, $key, $keyname, $keytype, $keysize, $keysize_max);

echo(formItem('text', 'MPDSection', 'MPDSection', 50, 50, $rs->fields['MPDSection']));
echo(formItem('text', 'Task', 'Task', 10, 10, $rs->fields['Task']));
echo(formItem('text', 'Applicability AC Type', 'ApplicabilityACType', 15, 15, $rs->fields['ApplicabilityACType']));
echo(formItem('text', 'Applicability Engine Type', 'ApplicabilityEngineType', 15, 15, $rs->fields['ApplicabilityEngineType']));
echo(formItem('text', 'Manuf Man Hours', 'ManufManHours', 10, 10, $rs->fields['ManufManHours']));
echo(formItem('text', 'Man Hours', 'ManHours', 10, 10, $rs->fields['ManHours']));
echo(formItem('textarea', 'Task Description', 'TaskDescription', 100, 3, $rs->fields['TaskDescription']));
echo(formItem('text', 'Notes', 'Notes', 50, 255, $rs->fields['Notes']));
echo(formItem('text', 'Threshold Value', 'ThresholdValue', 50, 50, $rs->fields['ThresholdValue']));
echo(formItem('text', 'Threshold Units', 'ThresholdUnits', 50, 50, $rs->fields['ThresholdUnits']));
echo(formItem('text', 'Repeat Value', 'RepeatValue', 50, 50, $rs->fields['RepeatValue']));
echo(formItem('text', 'Repeat Units', 'RepeatUnits', 50, 50, $rs->fields['RepeatUnits']));

midEditor($table, $update);

if ($update) {
	
	assocSpacer();
	$SQL = "SELECT mpdmaster2accesspanel.AccessPanel as MPDAP, accesspanelmaster.AccessPanel, accesspanelmaster.PanelDescription";
	$SQL .= " FROM accesspanelmaster RIGHT JOIN mpdmaster2accesspanel USING (AccessPanel)";
	$SQL .= " WHERE mpdmaster2accesspanel.MPDNumber='" . addslashes($_GET["num"]) . "'";
	$SQL .= " ORDER BY mpdmaster2accesspanel.AccessPanel";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Access Panels", "MPDAP", "AccessPanel", "PanelDescription", "/editors/accesspanel.php?num=", true, "mpdmaster2accesspanel", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Access Panels", "MPDAP", "AccessPanel", "PanelDescription", "", true, "mpdmaster2accesspanel", $_GET["num"]));
	
	assocSpacer();
	$SQL = "SELECT mpdmaster2zone.Zone as MPDZ, zonemaster.Zone, zonemaster.ZoneDesc";
	$SQL .= " FROM zonemaster RIGHT JOIN mpdmaster2zone USING (Zone)";
	$SQL .= " WHERE mpdmaster2zone.MPDNumber='" . addslashes($_GET["num"]) . "'";
	$SQL .= " ORDER BY mpdmaster2zone.Zone";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Zones", "MPDZ", "Zone", "ZoneDesc", "/editors/zone.php?num=", true, "mpdmaster2zone", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Zones", "MPDZ", "Zone", "ZoneDesc", "", true, "mpdmaster2zone", $_GET["num"]));
	
	assocSpacer();
	$SQL = "SELECT manufworkcard2mpd.ManufWorkCardNumber as MPDMWC, manufworkcardmaster.ManufWorkCardNumber, manufworkcardmaster.Title";
	$SQL .= " FROM manufworkcardmaster RIGHT JOIN manufworkcard2mpd USING (ManufWorkCardNumber)";
	$SQL .= " WHERE manufworkcard2mpd.MPDNumber='" . addslashes($_GET["num"]) . "'";
	$SQL .= " ORDER BY manufworkcard2mpd.ManufWorkCardNumber";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Manuf Workcards", "MPDMWC", "ManufWorkCardNumber", "Title", "/editors/manufworkcardnumber.php?num=", true, "mpd2manufworkcard", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Manuf Workcards", "MPDMWC", "ManufWorkCardNumber", "Title", "", true, "mpd2manufworkcard", $_GET["num"]));
	
	assocSpacer();
	$SQL = "SELECT workcard2mpd.WorkCardNumber as MPDWC, workcardmaster.WorkCardNumber, workcardmaster.Title";
	$SQL .= " FROM workcardmaster RIGHT JOIN workcard2mpd USING (WorkCardNumber)";
	$SQL .= " WHERE workcard2mpd.MPDNumber='" . addslashes($_GET["num"]) . "'";
	$SQL .= " ORDER BY workcard2mpd.WorkCardNumber";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Workcards", "MPDWC", "WorkCardNumber", "Title", "/editors/workcardnumber.php?num=", true, "mpd2workcard", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Workcards", "MPDWC", "WorkCardNumber", "Title", "", true, "mpd2workcard", $_GET["num"]));
}

endEditor();
?>
