<?php
require 'common.inc';
$required_class = 3;
require 'secure.inc';
require 'editors.inc';

$table = 'mrbtaskmaster';
$title = 'MRB Editor';
$key = 'MRBTask';
$keyname = 'MRB Task';
$keytype = 'text';
$keysize = 15;
$keysize_max = 50;

$record = array();
$record["InspectionType"] = $_POST["InspectionType"];
$record["MRBTaskDesc"] = $_POST["MRBTaskDesc"];
$record["MRBThresholdValue"] = $_POST["MRBThresholdValue"];
$record["MRBThresholdUnits"] = $_POST["MRBThresholdUnits"];
$record["MRBRepeatValue"] = $_POST["MRBRepeatValue"];
$record["MRBRepeatUnits"] = $_POST["MRBRepeatUnits"];
$record["ThresholdValue"] = $_POST["ThresholdValue"];
$record["ThresholdUnits"] = $_POST["ThresholdUnits"];
$record["RepeatValue"] = $_POST["RepeatValue"];
$record["RepeatUnits"] = $_POST["RepeatUnits"];
if (USE_AWL) {
	if ($_POST["AWL"] != "Y") $_POST["AWL"] = "N";
	$record["AWL"] = $_POST["AWL"];
}
if (USE_PRE) {
	if ($_POST["PRE"] != "Y") $_POST["PRE"] = "N";
	$record["PRE"] = $_POST["PRE"];
}
if ($_POST["CMR"] != "Y") $_POST["CMR"] = "N";
$record["CMR"] = $_POST["CMR"];
$record["LocationType"] = $_POST["LocationType"];
if ($_POST["FCA"] != "Y") $_POST["FCA"] = "N";
$record["FCA"] = $_POST["FCA"];
if ($_POST["AAP"] != "Y") $_POST["AAP"] = "N";
$record["AAP"] = $_POST["AAP"];
if ($_POST["SSI"] != "Y") $_POST["SSI"] = "N";
$record["SSI"] = $_POST["SSI"];
if ($_POST["ETOPS"] != "Y") $_POST["ETOPS"] = "N";
$record["ETOPS"] = $_POST["ETOPS"];
if ($_POST["AD"] != "Y") $_POST["AD"] = "N";
$record["AD"] = $_POST["AD"];
if ($_POST["LIFE"] != "Y") $_POST["LIFE"] = "N";
$record["LIFE"] = $_POST["LIFE"];
$record["Notes"] = $_POST["Notes"];

$update = beginEditor($table, $title, $record, $rs, $key, $keyname, $keytype, $keysize, $keysize_max);

echo(formItem('text', 'Inspection Type', 'InspectionType', 10, 48, $rs->fields['InspectionType']));
echo(formItem('textarea', 'Task Description', 'MRBTaskDesc', 80, 3, $rs->fields['MRBTaskDesc']));
echo(formItem('text', 'Carrier Threshold Value', 'ThresholdValue', 10, 48, $rs->fields['ThresholdValue']));
echo(formItem('text', 'Carrier Threshold Units', 'ThresholdUnits', 10, 48, $rs->fields['ThresholdUnits']));
echo(formItem('text', 'Carrier Repeat Value', 'RepeatValue', 10, 48, $rs->fields['RepeatValue']));
echo(formItem('text', 'Carrier Repeat Units', 'RepeatUnits', 10, 48, $rs->fields['RepeatUnits']));
echo(formItem('text', 'MRB Threshold Value', 'MRBThresholdValue', 10, 48, $rs->fields['MRBThresholdValue']));
echo(formItem('text', 'MRB Threshold Units', 'MRBThresholdUnits', 10, 48, $rs->fields['MRBThresholdUnits']));
echo(formItem('text', 'MRB Repeat Value', 'MRBRepeatValue', 10, 48, $rs->fields['MRBRepeatValue']));
echo(formItem('text', 'MRB Repeat Units', 'MRBRepeatUnits', 10, 48, $rs->fields['MRBRepeatUnits']));
echo(formItem('select', 'Location Type', 'LocationType', 1, '', $rs->fields['LocationType'], '',
	array('Component', 'Structural', 'Zonal', 'Lubrication', 'CPCP', 'Custom', 'Computer Controlled', 'AWL', 'SRL', 'HIRF/L')));
if (USE_AWL)
	echo(formItem('checkbox', 'AWL', 'AWL','','','Y',$rs->fields['AWL']));
if (USE_PRE)
	echo(formItem('checkbox', 'PRE', 'PRE','','','Y',$rs->fields['PRE']));
echo(formItem('checkbox', 'CMR', 'CMR','','','Y',$rs->fields['CMR']));
echo(formItem('checkbox', 'FCA', 'FCA','','','Y',$rs->fields['FCA']));
echo(formItem('checkbox', 'AAP', 'AAP','','','Y',$rs->fields['AAP']));
echo(formItem('checkbox', 'SSI', 'SSI','','','Y',$rs->fields['SSI']));
echo(formItem('checkbox', 'ETOPS', 'ETOPS','','','Y',$rs->fields['ETOPS']));
echo(formItem('checkbox', 'AD', 'AD','','','Y',$rs->fields['AD']));
echo(formItem('checkbox', 'LIFE', 'LIFE','','','Y',$rs->fields['LIFE']));
echo(formItem('textarea', 'Notes', 'Notes', 80, 3, $rs->fields['Notes']));

midEditor($table, $update);

if ($update) {
	assocSpacer();
	$SQL = "SELECT mrbtask2accesspanel.AccessPanel as MRBA, accesspanelmaster.AccessPanel, accesspanelmaster.PanelDescription";
	$SQL .= " FROM accesspanelmaster RIGHT JOIN mrbtask2accesspanel USING (AccessPanel)";
	$SQL .= " WHERE mrbtask2accesspanel.MRBTask='" . $_GET["num"] . "'";
	$SQL .= " ORDER BY mrbtask2accesspanel.AccessPanel;";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Access Panels", "MRBA", "AccessPanel", "PanelDescription", "/editors/accesspanel.php?num=", true, "mrbtask2accesspanel", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Access Panels", "MRBA", "AccessPanel", "PanelDescription", "", true, "mrbtask2accesspanel", $_GET["num"]));

	assocSpacer();
	$SQL = "SELECT mrbtask2zone.Zone as MRBZ, zonemaster.Zone, zonemaster.ZoneDesc";
	$SQL .= " FROM zonemaster RIGHT JOIN mrbtask2zone USING (Zone)";
	$SQL .= " WHERE mrbtask2zone.MRBTask='" . $_GET["num"] . "'";
	$SQL .= " ORDER BY mrbtask2zone.Zone;";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Zones", "MRBZ", "Zone", "ZoneDesc", "/editors/zone.php?num=", true, "mrbtask2zone", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Zones", "MRBZ", "Zone", "ZoneDesc", "", true, "mrbtask2zone", $_GET["num"]));

	assocSpacer();
	$SQL = "SELECT manufworkcard2mrbtask.ManufWorkCardNumber as MRBW, manufworkcardmaster.ManufWorkCardNumber, manufworkcardmaster.Title";
	$SQL .= " FROM manufworkcardmaster RIGHT JOIN manufworkcard2mrbtask USING (ManufWorkCardNumber)";
	$SQL .= " WHERE manufworkcard2mrbtask.MRBTask='" . $_GET["num"] . "'";
	$SQL .= " ORDER BY manufworkcard2mrbtask.ManufWorkCardNumber;";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Manuf. Work Cards", "MRBW", "ManufWorkCardNumber", "Title", "/editors/manufworkcardnumber.php?num=", true, "mrbtask2manufworkcard", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Manuf. Work Cards", "MRBW", "ManufWorkCardNumber", "Title", "", true, "mrbtask2manufworkcard", $_GET["num"]));

	assocSpacer();
	$SQL = "SELECT workcard2mrbtask.WorkCardNumber as MRBW, workcardmaster.WorkCardNumber, workcardmaster.Title";
	$SQL .= " FROM workcardmaster RIGHT JOIN workcard2mrbtask USING (WorkCardNumber)";
	$SQL .= " WHERE workcard2mrbtask.MRBTask='" . $_GET["num"] . "'";
	$SQL .= " ORDER BY workcard2mrbtask.WorkCardNumber;";
	if ($user_class >= 3)
		echo(assocTable($SQL, "Related Work Cards", "MRBW", "WorkCardNumber", "Title", "/editors/workcardnumber.php?num=", true, "mrbtask2workcard", $_GET["num"]));
	else
		echo(assocTable($SQL, "Related Work Cards", "MRBW", "WorkCardNumber", "Title", "", true, "mrbtask2workcard", $_GET["num"]));
}


endEditor();
?>
