<?
require 'constants.inc';
if ($debug) 
	require 'db/mysql_debug.php';
else
	require 'db/mysql.php';
require 'adodb/adodb.inc.php';
require 'user.inc';
require 'header.inc';
require 'footer.inc';

///////////////////////////////////
//     INITIALIZE SESSION        //
///////////////////////////////////

ob_implicit_flush(); // no buffer.. just output
session_start();
header ("Cache-Control: no-cache, must-revalidate");
header ("Pragma: no-cache");
session_register("commands");
session_register("menustatus");
session_register("edit_vars");
session_register("user_flags");
session_register("devdb");
if (! empty($_GET["pdf"]))
	$pdf = true;
else
	$pdf = false;

// gettext setup
$language = 'en';
putenv("LANG=$language");
setlocale(LC_ALL, $language);
$domain = 'messages';
bindtextdomain($domain, $base_path . "/include/locale");
textdomain($domain);

///////////////////////////////////
//    INITIALIZE DATABASE        //
///////////////////////////////////

if (!empty($devdb)) {
	// we're working on a development database!
	$db_db = $db_db . "_dev" . $devdb;
}

$DB = new db();
$DB->open($db_db, $db_host, $db_user, $db_pass);
$q = new query($DB);
$q2 = new query($DB);

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
$conn = &ADONewConnection("mysql");
$conn->PConnect($db_host, $db_user, $db_pass, $db_db);

///////////////////////////////////
//   START UTILITY FUNCTIONS     //
///////////////////////////////////

function getmicrotime() { 
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
}

function getChapter($MRBTask) {
	if ((preg_match("/^\d\d-\d\d\d$/", $MRBTask)) || // 33-001
		(preg_match("/^\d\d-\d\d-.*$/", $MRBTask)) || // 53-10-*
		(preg_match("/^\d\d-X-\d\d\d$/", $MRBTask)) || // 33-X-001
		(preg_match("/^\d\d-\d\d\d-\d\d$/", $MRBTask)) || // 52-700-01
		(preg_match("/^\d\d\d\d\d\d-\d\d\d$/", $MRBTask))) // 212000-201
		return substr(preg_replace("/[^0-9]/", "", $MRBTask), 0, 2);
	else
		return;
}

function getSection($MRBTask) {
	if ((preg_match("/^\d\d-\d\d-\d\d\d$/", $MRBTask)) || // 53-10-201
		(preg_match("/^\d\d-\d\d-.*$/", $MRBTask)) || // 53-10-*
		(preg_match("/^\d\d\d\d\d\d-\d\d\d$/", $MRBTask))) // 212000-201
		return substr(preg_replace("/[^0-9]/", "", $MRBTask), 2, 2);
	else
		return;
}

function firstChar($MyString) {
    return substr($MyString, 0, 1);
}

function secondChar($MyString) {
    return substr($MyString, 1, 1);
}

function thirdChar($MyString) {
    return substr($MyString, 2, 1);
}

function fourthChar($MyString) {
    return substr($MyString, 3, 1);
}

function parseMRBTaskNumber($MRBTask, &$ATAChapter, &$ATASection, &$OtherBit) {
    $MRBTask = preg_replace("/[^0-9]/", "", $MRBTask);
    $ATAChapter = substr($MRBTask, 0, 2);
    $ATASection = substr($MRBTask, 2, 2);
    $OtherBit = substr($MRBTask, 4, strlen($MRBTask) - 5);
}

function FormatATA($Chapter, $Section, $Output) {
    global $q2, $DB;
        
    if ($Output == "Section") {
        $SQL = "SELECT AreaDesc FROM atasubchapters WHERE ATANumber='" . $Chapter . "' AND ATASection='" . $Section . "'";
    }
    else if ($Output == "Chapter") {
        $SQL = "SELECT ATADesc FROM ata WHERE ATANumber='" . $Chapter . "'";
    }
    else {
        $FormatATA = "";
        return;
    }

    $q2->query($DB, $SQL);
    $q2->getrow();

    if ($q2->numrows() < 1) {
			if (empty($Chapter) && empty($Section))
				return "N/A";
			else
        return strtoupper("ATA " . $Chapter . "-" . $Section);
    }
    else if ($Output == "Section") {
        return strtoupper($q2->field("AreaDesc"));
    }
    else if ($Output == "Chapter") {
        return strtoupper($Chapter . " - " . $q2->field("ATADesc"));
    }

    return;
    
    $q2->close();
    
}

function fillLabel($LabelName, $ColumnName, $SQL) {
    global $q2, $DB;
    
    $q2->query($DB, $SQL);
    
    if ($q2->numrows() < 1) {
        return "";
    }
    else {
        $myCaption = "";
        while ($q2->getrow()) {
            if ($myCaption != "") {
                $myCaption .= ", " . $q2->field($ColumnName);
            }
            else {
                $myCaption = $q2->field($ColumnName);
            }
        }
        
        return $myCaption;
    }
    $q2->close();
    
}

function dbmod(&$commands, $comment, $user, $tstamp) {
    global $q2, $DB, $devdb;

    $finalSQL = "";
   
    $q2->query($DB, "BEGIN;");  // begin transaction 

    for ($i = 0; $i < count($commands); $i++) {
        if ($commands[$i][1] == 'W' || $commands[$i][1] == 'E') { // waiting or error
            $q2->query($DB, $commands[$i][0]);
            if ($q2->error()) {
                // error occured
                $commands[$i][1] = 'E'; // error
                $commands[$i][2] = $q2->error();
            }
            else {
                $commands[$i][1] = 'C'; // complete
                $commands[$i][2] = '';
                $finalSQL .= $commands[$i][0] . ";";
            }
        }
    }

    if (dbmod_num_complete($commands) == count($commands)) {
	// all were successful.. commit transaction
	$q2->query($DB, "COMMIT;");

	// do our logging too..
	$finalSQL = addslashes($finalSQL);
        $SQL = "INSERT INTO log (tstamp, username, comment, commands) VALUES ('$tstamp', '$user', '$comment', '$finalSQL')";
        $q2->query($DB, $SQL);
	// should we add something to make sure it was logged?
    }


    // not all were successfull.. roll 'em back
    $q2->query($DB, "ROLLBACK;");

    return true;    
}

function dbmod_num_complete($commands) {
    $total = 0;
    for ($i = 0; $i < count($commands); $i++) {
        if ($commands[$i][1] == 'C') {
            $total++;
        }
    }
    return $total;
}

function dbmod_errors($commands) {
    $finalstring = "";
    for ($i = 0; $i < count($commands); $i++) {
        if ($commands[$i][1] == 'E') {
           $finalstring .= "WHILE ISSUING: " . $commands[$i][0] . ", I RECIEVED: " . $commands[$i][2] . "<br>";
        }
    }
    return $finalstring;    
}

function addcommand($command, &$commands, $status='W') {
	$commands[] = array($command, $status, "");
}

function formItem($mytype, $label, $formname, $size='', $maxlength='', $value='', $checked='0', $selectvals='', $extra='') {
	$value = stripslashes($value);
	$final = '';
	$final .= "<tr>\n";
	$final .= "<td class=\"FormLabelCell\"><nobr><font class=\"FormLabel\">" . $label . "</font></nobr></td><td width=\"15\">&nbsp;</td>\n";
	$final .= "<td width=\"100%\" class=\"FormInputCell\">\n";

	if (($mytype == 'text') || ($mytype == 'password')) {
		$final .= "<input type=\"" . $mytype . "\" name=\"" . $formname . "\" value=\"" . $value . "\" size=\"" .  $size . "\" maxlength=\"" . $maxlength . "\" class=\"FormInput\">";
	}
	else if ($mytype == 'checkbox') {
		$final .= "<input type=\"checkbox\"";
		if ($checked == 'Y') 
			$final .= " checked";
		if ($formname == 'delete')
			$final .= " onClick=\"javascript: if ((this.checked) && confirm('Are you sure?')) document.MainForm.submit(); else this.checked=false;\"";
		$final .= " name=\"" . $formname . "\" class=\"FormInput\" value=\"" . $value . "\">";
	}
	else if ($mytype == 'hidden') {
		$final .= "<font class=\"FormStatic\">" . $value . "</font><input type=\"hidden\" name=\"" . $formname . "\" value=\"" . $value . "\">";
	}
	else if ($mytype == 'select') {
		$final .= "<select name=\"" . $formname . "\" size=\"" . $size . "\" class=\"FormSelect\"" . $extra . ">\n";
        	foreach($selectvals as $a) {
			if (is_array($a)) {
				$final .= "<option value=\"" . $a[0] . "\"";
				if ($value == $a[0])
					$final .= " selected";
				$final .= ">" . $a[1] . "</option>\n";
			}
			else {
				$final .= "<option value=\"" . $a . "\"";
                		if ($value == $a) 
                        		$final .= " selected";
                		$final .= ">" . $a . "</option>\n";
			}
        	}
		$final .= "</select>\n";
	}
	else if ($mytype == 'date') {
		$final .= makeDateField($formname, $value);
	}
	else if ($mytype == 'textarea') {
		$final .= "<textarea name=\"" . $formname . "\" cols=\"" . $size . "\" rows=\"" . $maxlength . "\" class=\"FormInput\">" . $value . "</textarea>";
	}
	else {
		$final .= "&nbsp;";
	}

	$final .= "</td></tr>\n";

	return $final;
}

function makeDateField($formname, $value='') {
	$startyear = 1960;
	$final = '';
	$months = array(1 => 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

	if (strlen($value) < 8) { $value = ""; } // if it's less than 8 long, it's definitely not a valid timestamp
	
	$ascvar = $formname . "_month";
	$final .= "  <select name=\"$ascvar\" class=\"FormSelect\">\n";
	$final .= "    <option";
	if (empty($value)) { $final .= " SELECTED"; }
	$final .= " value=\"---\">---</option>\n";
	for ($cur = 1; $cur <= 12; $cur++) {
		if ((! empty($value)) && (date("m", $value) == $cur)) { $selected = " SELECTED"; }
		$final .= "    <option value=$cur$selected>$months[$cur]</option>\n";
		$selected = "";
	}
	$final.="  </select>\n";
 
	$ascvar = $formname . "_day";
	$final .= "  <select name=\"$ascvar\" class=\"FormSelect\">\n";
	$final .= "    <option";
	if (empty($value)) { $final .= " SELECTED"; }
	$final .= " value=\"--\">--</option>\n";
	for ($cur = 1; $cur <= 31; $cur++) {
		if ((! empty($value)) && (date("d", $value) == $cur)) { $selected = " SELECTED"; }
		$final .= "    <option value=$cur$selected>$cur</option>\n";
		$selected = "";
	}
	$final.="  </select>\n";
 
	$ascvar = $formname . "_year";
	$final .= "  <select name=\"$ascvar\" class=\"FormSelect\">\n";
	$final .= "    <option";
	if (empty($value)) { $final .= " SELECTED"; }
	$final .= " value=\"----\">----</option>\n";
	for ($cur = date("Y"); $cur >= $startyear; $cur--) {
		if ((! empty($value)) && (date("Y", $value) == $cur)) { $selected = " SELECTED"; }
		$final .= "    <option value=$cur$selected>$cur</option>\n";
		$selected = "";
	}
	$final.="  </select>";
	$final .= " &nbsp;<input class=\"FormSubmit\" type=\"button\" name=\"dummy\" onClick=\"selectToday('" . $formname . "')\" value=\"Today\">";

	return $final;
}
	

function menuEntry($sessioncmd, $isopen, $label, $spacers=0, $pdflink=false) {
	$final = "<nobr>";
	for ($i = 1; $i <= $spacers; $i++) {
		$final .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	}
	$final .= "<a href=\"" . $sessioncmd . "\"";
	if ($label == "Logout")
		$final .= " class=\"logout\">";
	else
		$final .= " class=\"menu\">";

	if ($isopen == 1 || $isopen == 0) {
		$final .= "<font class=\"menumark\">";
		if ($isopen == 0)
			$final .= "+";
		else
			$final .= "-";
		$final .= "</font> ";
	}

	$final .= $label . "</a>";
	if ($pdflink)
		$final .= "&nbsp;&nbsp;<a href=\"" . $sessioncmd . "?pdf=yes\"" . " class=\"menu\">PDF</a>";
	$final .= "</nobr><br>";

	echo($final);
}

function endsession() {
	session_destroy();
	$p = session_get_cookie_params();
	setcookie(session_name(), "", 0, $p["path"], $p["domain"]);
}

function statusSelect($selected="Draft") {
	$final = '';
        $final .= "<tr>\n";
        $final .= "<td class=\"FormLabelCell\"><nobr><font class=\"FormLabel\">Card Status</font></nobr></td><td width=\"15\">&nbsp;</td>\n";
        $final .= "<td width=\"100%\" class=\"FormInputCell\">\n";
	$final .= "<select name=\"CardStatus\" size=\"1\" class=\"FormSelect\">\n";
	foreach(array("Draft","Active","Inactive","Superceded","Suspended","Archived") as $a) {
		$final .= "<option value=\"" . $a . "\""; 
		if ($selected == $a)
			$final .= " selected";
		$final .= ">" . $a . "</option>\n";
	}
	$final .= "</td></tr>\n";

	return $final;
}

function new_assocTable($SQL, $title, $mainfield, $checkfield, $descfield, $url, $closetable=true, $relatedadd, $num, $mainlabel="Number", $desclabel="Description", $extrafield="", $extralabel="", $extrafield2="", $extralabel2="") {
	global $q2, $DB;

	$formout = ''; $final = '';

	$final .= "<tr><td class=\"FormLabelCell\"><font class=\"FormLabel\"><a name=\"" . $relatedadd . "\">" . $title . "</a></font></td><td colspan=\"2\">&nbsp;</td></tr>";

	$final .= "<tr><td colspan=\"2\">&nbsp;</td><td><table border=\"0\"><tr><td align=\"left\"><font class=\"FormLabel\">" . $mainlabel . "</font></td>";
	$final .= "<td width=\"15\">&nbsp;</td>";
	if ($extrafield) 
		$final .= "<td align=\"left\"><font class=\"FormLabel\">" . $extralabel . "</font></td><td width=\"15\">&nbsp;</td>";

	$final .= "<td align=\"left\"><font class=\"FormLabel\">" . $desclabel . "</font></td><td width=\"15\">&nbsp;</td><td align=\"right\"><font class=\"FormLabel\">Delete</font></td></tr>\n";

	$q2->query($DB, $SQL);
	$i = 0;
	while ($q2->getrow()) {
		$i++;
		if ($q2->field($descfield) == "0")
			$mydesc = "N/A";
		else
			$mydesc = $q2->field($descfield);

		if ($q2->field($mainfield) != $q2->field($checkfield))
			$myclass = "boldred";
		else
			$myclass = "normal";

		if ($q2->field($checkfield) == "0")
			$myid = "";
		else
			$myid = $q2->field($checkfield);

		$final .= "<tr><td class=\"FormInputCell\">";
		if (! empty($url))
			$final .= "<a href=\"" . $url . $q2->field($mainfield) . "\" class=\"" . $myclass . "\">";
		else
			$final .= "<font class=\"" . $myclass . "\">";

		if (stristr($mainfield, "date") && (strlen($q2->field($mainfield)) >= 8))
			$final .= show_date($q2->field($mainfield));
		else
			$final .= $q2->field($mainfield);

		if (! empty($url))
			$final .=  "</a>";
		else
			$final .= "</font>";
		$final .= "&nbsp;</td>\n<td>&nbsp;</td>\n";
		if ($extrafield)
			$final .= "<td><font class=\"DESCassocTable\">" . $q2->field($extrafield) . "&nbsp;</font></td>\n<td>&nbsp;</td>\n";
		$final .= "<td><font class=\"DESCassocTable\">" . $mydesc . "&nbsp;";
		$final .= "</font></td><td>&nbsp;</td>\n<td class=\"FormInputCell\">";
		$formout .= "<form action=\"/relatedadd.php?delete=true\" method=\"POST\" name=\"" . $relatedadd . "_" . $i . "\">\n";
		$formout .= "<input type=\"hidden\" value=\"" . $relatedadd . "\" name=\"type\">\n";
		if (($relatedadd == 'devcard2reviewdates_faa') || ($relatedadd == 'devcard2reviewdates_car')) {
			$formout .= "<input type=\"hidden\" value=\"" . $q2->field("ReviewDateID") . "\" name=\"id\">\n";
		}
		else {
			$formout .= "<input type=\"hidden\" value=\"" . $num . "\" name=\"num\">\n";
			$formout .= "<input type=\"hidden\" value=\"" . $q2->field($mainfield) . "\" name=\"id\">\n";
			if ($relatedadd == 'rfstracking2document') //special case.. need the documenttype
				$formout .= "<input type=\"hidden\" value=\"" . $q2->field($descfield) . "\" name=\"DocumentType\">\n";
		}
		$final .= "<input type=\"checkbox\" name=\"bogus\" value=\"\"";
		$final .= " onClick=\"javascript: if ((this.checked) && confirm('Are you sure?')) { document." . $relatedadd . "_" . $i . ".submit(); } else { this.checked = false; }\">";
		$formout .= "</form>";
		$final .= "</td></tr>\n";

	}


/*
	if ($relatedadd == 'rfstracking2document') {
		//special case.. need the type dropdown
       		$final .= "<tr><td><input type=\"text\" name=\"id\" class=\"SmallFormInput\"></td><td>&nbsp;</td>\n";
       		$final .= "<td><select name=\"DocumentType\" size=\"1\">\n";
		$final .= "<option value=\"Workcard\">Workcard</option>\n";
		$final .= "<option value=\"EO\">EO</option>\n";
		$final .= "<option value=\"TLM\">TLM</option>\n";
		$final .= "<option value=\"FCD\">FCD</option>\n";
		$final .= "<option value=\"AD\">AD</option>\n";
		$final .= "<option value=\"SB\">SB</option>\n";
		$final .= "<option value=\"COMMAND\">COMMAND</option>\n";
		$final .= "<option value=\"NONE\">No Specific</option>\n";
		$final .= "</select></td><td>&nbsp;</td>\n";
       		$final .= "<td><input type=\"submit\" name=\"Add\" value=\"Add\" class=\"SmallFormInput\"></td></tr>\n";

	}
*/

	if (($relatedadd == 'devcard2reviewdates_faa') || ($relatedadd == 'devcard2reviewdates_car')) {
		//special case.. need the direction dropdown, date field
		$final .= "<tr><td>" . makeDateField($relatedadd) . "</td>\n";
		$final .= "<td>&nbsp;</td>";
		$final .= "<td><select name=\"" . $relatedadd . "_Direction\" size=\"1\">\n";
		if ($relatedadd == 'devcard2reviewdates_faa') {
			$final .= "<option value=\"Sent to FAA\">Sent to FAA</option>\n";
			$final .= "<option value=\"Rcvd from FAA\">Rcvd from FAA</option>\n";
		}
		else {
			$final .= "<option value=\"Sent to Carrier\">Sent to Carrier</option>\n";
			$final .= "<option value=\"Rcvd from Carrier\">Rcvd from Carrier</option>\n";
		}
		$final .= "</select></td>\n";
		$jscript = "document." . $relatedadd . "_new." . $relatedadd . "_month.value = document.MainForm." . $relatedadd . "_month.value;";
		$jscript .= "document." . $relatedadd . "_new." . $relatedadd . "_day.value = document.MainForm." . $relatedadd . "_day.value;";
		$jscript .= "document." . $relatedadd . "_new." . $relatedadd . "_year.value = document.MainForm." . $relatedadd . "_year.value;";
		$jscript .= "document." . $relatedadd . "_new.Direction.value = document.MainForm." . $relatedadd . "_Direction.value;";
		$jscript .= "document." . $relatedadd . "_new.submit();";
		$final .= "<td><input type=\"button\" name=\"Add\" value=\"Add\" class=\"SmallFormInput\" onClick=\"" . $jscript . "\"></td></tr>\n";

		$formout .= "<form action=\"/relatedadd.php\" method=\"POST\" name=\"" . $relatedadd . "_new\">\n";
		$formout .= "<input type=\"hidden\" value=\"" . $relatedadd . "\" name=\"type\">\n";
		$formout .= "<input type=\"hidden\" name=\"" . $relatedadd . "_month\" value=\"\">\n";
		$formout .= "<input type=\"hidden\" name=\"" . $relatedadd . "_day\" value=\"\">\n";
		$formout .= "<input type=\"hidden\" name=\"" . $relatedadd . "_year\" value=\"\">\n";
		$formout .= "<input type=\"hidden\" name=\"Direction\" value=\"\">\n";
		$formout .= "<input type=\"hidden\" name=\"num\" value=\"" . $num . "\">\n";
		$formout .= "</form>\n";
	}
	else {
		$formout .= "<form action=\"/relatedadd.php\" method=\"POST\" name=\"" . $relatedadd . "_new\">\n";
		$formout .= "<input type=\"hidden\" name=\"num\" value=\"" . $num . "\">\n";
		$formout .= "<input type=\"hidden\" name=\"id\" value=\"\">\n";
		$formout .= "<input type=\"hidden\" name=\"type\" value=\"" . $relatedadd . "\">\n";
		$final .= "<tr><td><input type=\"text\" name=\"" . $relatedadd . "_id\" class=\"SmallFormInput\"></td><td>&nbsp;</td>\n";
		if ($extrafield)
			$final .= "<td><input type=\"text\" name=\"extra\" class=\"SmallFormInput\"></td><td>&nbsp;</td>\n";
		$final .= "<td colspan=\"3\"><input type=\"button\" name=\"Add\" value=\"Add\" class=\"SmallFormInput\" onClick=\"document." . $relatedadd . "_new.id.value = document.MainForm." . $relatedadd . "_id.value; document." . $relatedadd . "_new.submit()\"></td></tr>\n";
		$formout .= "</form>\n";
	}

	
	if ($closetable)
		$final .= "</table></td></tr>\n";
	
	echo $final;
	return $formout;
}

function assocTable($SQL, $title, $mainfield, $checkfield, $descfield, $url, $closetable=true, $relatedadd, $num, $mainlabel="Number", $desclabel="Description", $extrafield="", $extralabel="", $extrafield2="", $extralabel2="") {
	global $q2, $DB;

	$final = '';
	$final .= "<tr><td class=\"FormLabelCell\"><font class=\"FormLabel\"><a name=\"" . $relatedadd . "\">" . $title . "</a></font></td><td colspan=\"2\">&nbsp;</td></tr>";

	$final .= "<tr><td colspan=\"2\">&nbsp;</td><td><table border=\"0\"><tr><td align=\"left\"><font class=\"FormLabel\">" . $mainlabel . "</font></td>";
	$final .= "<td width=\"15\">&nbsp;</td>";
	if ($extrafield) 
		$final .= "<td align=\"left\"><font class=\"FormLabel\">" . $extralabel . "</font></td><td width=\"15\">&nbsp;</td>";

	$final .= "<td align=\"left\"><font class=\"FormLabel\">" . $desclabel . "</font></td><td width=\"15\">&nbsp;</td><td align=\"right\"><font class=\"FormLabel\">Delete</font></td></tr>\n";

	$q2->query($DB, $SQL);
	$i = 0;
	while ($q2->getrow()) {
		$i++;
		if ($q2->field($descfield) == "0")
			$mydesc = "N/A";
		else
			$mydesc = $q2->field($descfield);

		if ($q2->field($mainfield) != $q2->field($checkfield))
			$myclass = "boldred";
		else
			$myclass = "normal";

		if ($q2->field($checkfield) == "0")
			$myid = "";
		else
			$myid = $q2->field($checkfield);

		$final .= "<tr><td class=\"FormInputCell\">";
		if (! empty($url))
			$final .= "<a href=\"" . $url . $q2->field($mainfield) . "\" class=\"" . $myclass . "\">";
		else
			$final .= "<font class=\"" . $myclass . "\">";
		$final .= $q2->field($mainfield);
		if (! empty($url))
			$final .=  "</a>";
		else
			$final .= "</font>";
		$final .= "&nbsp;</td>\n<td>&nbsp;</td>\n";
		if ($extrafield)
			$final .= "<td><font class=\"DESCassocTable\">" . $q2->field($extrafield) . "&nbsp;</font></td>\n<td>&nbsp;</td>\n";
		$final .= "<td><font class=\"DESCassocTable\">" . $mydesc . "&nbsp;";
		$final .= "</font></td><td>&nbsp;</td>\n<td class=\"FormInputCell\"><form action=\"/relatedadd.php?delete=true\" method=\"POST\" name=\"" . $relatedadd . "_" . $i . "\">\n";
		$final .= "<input type=\"hidden\" value=\"" . $relatedadd . "\" name=\"type\">\n";
		$final .= "<input type=\"hidden\" value=\"" . $num . "\" name=\"num\">\n";
		if ($relatedadd == 'rfstracking2document') //special case.. need the documenttype
			$final .= "<input type=\"hidden\" value=\"" . $q2->field($descfield) . "\" name=\"DocumentType\">\n";
		else if ($relatedadd == 'workcard2references') //special case.. need the reftype
			$final .= "<input type=\"hidden\" value=\"" . $q2->field($descfield) . "\" name=\"RefType\">\n";
		$final .= "<input type=\"checkbox\" name=\"id\" value=\"" . $q2->field($mainfield) . "\"";
		$final .= " onClick=\"javascript: if ((this.checked) && confirm('Are you sure?')) { document." . $relatedadd . "_" . $i . ".submit(); } else { this.checked = false; }\">";
		$final .= "</form></td></tr>\n";

	}

	$final .= "<form action=\"/relatedadd.php\" method=\"POST\">\n";
       	$final .= "<input type=\"hidden\" name=\"num\" value=\"" . $num . "\">\n";
       	$final .= "<input type=\"hidden\" name=\"type\" value=\"" . $relatedadd . "\">\n";

	if ($relatedadd == 'rfstracking2document') {
		//special case.. need the type dropdown
		$final .= "<tr><td><input type=\"text\" name=\"id\" class=\"SmallFormInput\"></td><td>&nbsp;</td>\n";
		$final .= "<td><select name=\"DocumentType\" size=\"1\">\n";
		$final .= "<option value=\"Workcard\">Workcard</option>\n";
		$final .= "<option value=\"EO\">EO</option>\n";
		$final .= "<option value=\"TLM\">TLM</option>\n";
		$final .= "<option value=\"FCD\">FCD</option>\n";
		$final .= "<option value=\"AD\">AD</option>\n";
		$final .= "<option value=\"SB\">SB</option>\n";
		$final .= "<option value=\"COMMAND\">COMMAND</option>\n";
		$final .= "<option value=\"NONE\">No Specific</option>\n";
		$final .= "</select></td><td>&nbsp;</td>\n";
		$final .= "<td><input type=\"submit\" name=\"Add\" value=\"Add\" class=\"SmallFormInput\"></td></tr>\n";
	}
	else if ($relatedadd == 'workcard2references') {
		//special case.. need the type dropdown
		$final .= "<tr><td><input type=\"text\" name=\"id\" class=\"SmallFormInput\"></td><td>&nbsp;</td>\n";
		$final .= "<td><select name=\"RefType\" size=\"1\">\n";
		$final .= "<option value=\"AMM\">AMM</option>\n";
		$final .= "<option value=\"EO\">EO</option>\n";
		$final .= "<option value=\"AD\">AD</option>\n";
		$final .= "<option value=\"SB\">SB</option>\n";
		$final .= "<option value=\"IPC\">IPC</option>\n";
		$final .= "<option value=\"WDM\">WDM</option>\n";
		$final .= "<option value=\"SRM\">SRM</option>\n";
		$final .= "<option value=\"CMM\">CMM</option>\n";
		$final .= "<option value=\"NDT\">NDT</option>\n";
		$final .= "</select></td><td>&nbsp;</td>\n";
		$final .= "<td><input type=\"submit\" name=\"Add\" value=\"Add\" class=\"SmallFormInput\"></td></tr>\n";
	}
	else {
       		$final .= "<tr><td><input type=\"text\" name=\"id\" class=\"SmallFormInput\"></td><td>&nbsp;</td>\n";
		if ($extrafield)
       			$final .= "<td><input type=\"text\" name=\"extra\" class=\"SmallFormInput\"></td><td>&nbsp;</td>\n";
       		$final .= "<td colspan=\"3\"><input type=\"submit\" name=\"Add\" value=\"Add\" class=\"SmallFormInput\"></td></tr>\n";
	}

       	$final .= "</form>\n";
	
	if ($closetable)
		$final .= "</table></td></tr>\n";
	
	return $final;
}

function external_link($item, $type = 'workcards', $linktext = 'view') {
	if (external_exists($item, $type)) {
		return "<a href=\"/doc/external.php?item=" . urlencode($item) . "&type=" . urlencode($type) . "\" target=\"_blank\">" . $linktext . "</a>";
	}
	return;
}

function get_external_path($item, $type = 'workcards') {
	global $base_path;
	if (! empty($item)) {
		if ($type == 'workcards')
			$ext = ".pdf";
		else if ($type == 'graphics')
			$ext = ".png";
		else
			$ext = "";
		return($base_path . "/doc/external/" . $type . "/" . escapeshellcmd($item) . $ext);
	}
}
                
function external_exists($item, $type = 'workcards') {
	$filename = get_external_path($item, $type);
	if (file_exists($filename))
			return true;
	else
		return false;
}               

function topdf($buffer) {
	global $base_path, $pdf, $MERGEPDF;

	$pdf = false; // resist infinite loops!
         
	$fname = getmicrotime();
	$fp = fopen("/tmp/" . $fname . ".html", "w");
	fputs($fp, $buffer, strlen($buffer));
	fclose($fp);

	if (! file_exists("/tmp/$fname.html"))
		header("Location:/index.php");
                 
	# Run HTMLDOC
	system("/usr/local/bin/htmldoc -t pdf --left .25in --right .25in --fontsize 8 --landscape --quiet --jpeg --header ... --webpage $options /tmp/$fname.html > $base_path/tmp/$fname.pdf");
	if (file_exists("/tmp/$fname.html"))
		unlink("/tmp/" . $fname . ".html");

	if (isset($MERGEPDF) && sizeof($MERGEPDF > 0))
		$fname = mergepdf(array_unshift($MERGEPDF, $fname), array_unshift($MERGEPDF_BOOKMARKS, "Master Record Card"));
	return $fname;
}

function mergepdf($elements, $bookmarks) {
	global $base_path;
	$fname = getmicrotime() . ".pdf";	
	$p = pdf_new();
	pdf_open_file($p, $base_path . "/tmp/" . $fname);
	pdf_set_parameter($p, "serial", "B40300-102690-2200XX-8C333B");
	pdf_set_info($p, "Creator", "Cavok International");
	pdf_set_info($p, "Author", "Cavok International");
	pdf_set_info($p, "Title", "Report");

	foreach ($elements as $pdf) {
		$doc = pdf_open_pdi($p, $pdf, "", 0);
		if (!$doc) {
			echo("Couldn't open PDF input file '" . $pdf . "'\n");
			continue;
		}
		$newpdf = true;
		$pagecount = pdf_get_pdi_value($p, "/Root/Pages/Count", $doc, 0, 0);
		for ($i = 1; $i <= $pagecount; $i++) {
			$page = pdf_open_pdi_page($p, $doc, $i, "");
			if (!$page){
				die("Couldn't open page $i in $pdf.\n");
			}
			if (empty($sheetwidth))
				$sheetwidth = pdf_get_pdi_value($p,"width",$doc,$page,0);
			if (empty($sheetheight))
				$sheetheight = pdf_get_pdi_value($p,"height",$doc,$page,0);
	
			pdf_begin_page($p,$sheetwidth,$sheetheight);
			if ($newpdf) {
				pdf_add_bookmark($p, array_pop($bookmarks), 0, 0);
				$newpdf = false;
			}
			pdf_place_pdi_page($p,$page,0.0,0.0,1.0,1.0);
			pdf_close_pdi_page($p,$page);
			pdf_end_page($p);
		}
	}

	pdf_close($p);
	pdf_delete($p);
	
	return $fname;
}
		
function int2str_status($status) {
	switch($status) {
		case 1:
			return "Urgent";
			break;
		case 2:
			return "High";
			break;
		case 3:
			return "Moderate";
			break;
		case 4:
			return "Low";
			break;
	}
	return;
}
 
function parse_date_form ($fn) {
	$strdate = $_POST[$fn . "_year"] . "-" . $_POST[$fn . "_month"] . "-" . $_POST[$fn . "_day"];
	if (($strdate == "--") || ($strdate == "-----------") || (($timestamp = strtotime($strdate)) === -1))
		$timestamp = 0;
	return $timestamp;
}

function get_file_extension($type) {
	switch ($type) {
		case "graphics":
			return ".png";
			break;

		case "workcards":
			return ".pdf";
			break;
	}
	return;
}

function get_file_headers($item, $extension, $filename) {
	switch ($extension) {
		case ".pdf":
			header("Content-type: application/pdf");
			header("Content-disposition: inline; filename=" . $item . ".pdf");
			header("Content-length: " . filesize($filename));
			break;
		case ".png":
			header("Content-type: image/png"); 
			break;
		case ".jpg":
			header( "Content-type: image/jpeg"); 
			break;
	}
}

function show_date($mydate, $showtime = false) {
	if (strlen($mydate) < 8) // bad
		return;

	if ($showtime)
		return date('Y-m-d H:i', $mydate); // good w/time
	else
		return date('Y-m-d', $mydate); // good wo/time
}
?>
