<?

function makeTLM($format = 'NONE', $location_type = '', $report_name = 'N/A') {
	global $q, $DB, $long_company_name, $ac_type;

	if (($format == 'ATA') || ($format == 'NONE')) { // ATA Format
		base_header('MRB Task by ATA - ' . $report_name);
		$SQL = "DROP TABLE IF EXISTS TLMtemp";
		$q->query($DB, $SQL);

		$SQL = "CREATE TEMPORARY TABLE TLMtemp SELECT workcard2mrbtask.WorkCardNumber, mrbtaskmaster.* FROM workcard2mrbtask";
		$SQL .= " LEFT JOIN mrbtaskmaster USING (MRBTask)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcard2mrbtask.WorkCardNumber = workcardmaster.WorkCardNumber)";
		$SQL .= " WHERE ((mrbtaskmaster.LocationType='" . $location_type . "')";
		if (USE_PRE)
			$SQL .= " AND (mrbtaskmaster.PRE!='Y')";
		if (USE_AWL)
			$SQL .= " AND (mrbtaskmaster.AWL!='Y')";
		if ((! TLM_INCLUDE_CMR) && ($location_type != 'CMR'))
			$SQL .= " AND (mrbtaskmaster.CMR!='Y')";
		$SQL .= " AND (workcardmaster.CardStatus='Active'))";
		$q->query($DB, $SQL);

		$SQL = "INSERT INTO TLMtemp (MRBTask,InspectionType,MRBTaskDesc,MRBThresholdValue,MRBThresholdUnits,MRBRepeatValue,MRBRepeatUnits,ThresholdValue,ThresholdUnits,RepeatValue,RepeatUnits,";
		if (USE_AWL)
			$SQL .= "AWL,";
		if (USE_PRE)
			$SQL .= "PRE,";
		$SQL .= "CMR,LocationType,FCA,AAP,SSI,ETOPS,AD,LIFE,Notes) SELECT DISTINCT mrbtaskmaster.MRBTask,mrbtaskmaster.InspectionType,mrbtaskmaster.MRBTaskDesc,mrbtaskmaster.MRBThresholdValue,mrbtaskmaster.MRBThresholdUnits,mrbtaskmaster.MRBRepeatValue,mrbtaskmaster.MRBRepeatUnits,mrbtaskmaster.ThresholdValue,mrbtaskmaster.ThresholdUnits,mrbtaskmaster.RepeatValue,mrbtaskmaster.RepeatUnits,";
		if (USE_AWL)
			$SQL .= "mrbtaskmaster.AWL,";
		if (USE_PRE)
			$SQL .= "mrbtaskmaster.PRE,";
		$SQL .= "mrbtaskmaster.CMR,mrbtaskmaster.LocationType,mrbtaskmaster.FCA,mrbtaskmaster.AAP,mrbtaskmaster.SSI,mrbtaskmaster.ETOPS,mrbtaskmaster.AD,mrbtaskmaster.LIFE,mrbtaskmaster.Notes FROM mrbtaskmaster";
		$SQL .= " LEFT JOIN workcard2mrbtask ON (mrbtaskmaster.MRBTask = workcard2mrbtask.MRBTask)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcardmaster.WorkCardNumber = workcard2mrbtask.WorkCardNumber)";
		$SQL .= " WHERE ((workcard2mrbtask.MRBTask IS NULL)";
		$SQL .= " OR (workcardmaster.CardStatus != 'Active'))";
		$SQL .= " AND ((mrbtaskmaster.LocationType='" . $location_type . "')";
		if (USE_PRE)
			$SQL .= " AND (mrbtaskmaster.PRE!='Y')";
		if (USE_AWL)
			$SQL .= " AND (mrbtaskmaster.AWL!='Y')";
		if ((! TLM_INCLUDE_CMR) && ($location_type != 'CMR'))
			$SQL .= " AND (mrbtaskmaster.CMR!='Y')";
		$SQL .= ")";
		$q->query($DB, $SQL);

		$SQL = " SELECT MRBTask, COUNT(*) as mrbcount FROM TLMtemp GROUP BY MRBTask HAVING (mrbcount > 1)";
		$q->query($DB, $SQL);
		$SQL = "DELETE FROM TLMtemp WHERE (MRBTask IS NULL AND WorkCardNumber IS NULL)";
		while ($q->getrow())
			$SQL .= " OR (WorkCardNumber='' AND MRBTask='" . addslashes($q->field("MRBTask")) . "')";
		$q->query($DB, $SQL);

		$SQL = "SELECT * FROM TLMtemp";
		$SQL .= " ORDER BY MRBTask, WorkCardNumber";
	}
	else if ($format == 'ZONE') { // Zone Format
		base_header('MRB Task by Zone - ' . $report_name);
		$SQL = "DROP TABLE IF EXISTS TLMtemp";
		$q->query($DB, $SQL);

		$SQL = "CREATE TEMPORARY TABLE TLMtemp SELECT workcard2mrbtask.WorkCardNumber, mrbtaskmaster.*, mrbtask2zone.Zone, zonemaster.ZoneDesc FROM workcard2mrbtask";
		$SQL .= " LEFT JOIN mrbtaskmaster USING (MRBTask)";
		$SQL .= " LEFT JOIN mrbtask2zone USING (MRBTask)";
		$SQL .= " LEFT JOIN zonemaster USING (Zone)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcard2mrbtask.WorkCardNumber = workcardmaster.WorkCardNumber)";
		$SQL .= " WHERE ((mrbtaskmaster.LocationType='" . $location_type . "')";
		if (USE_PRE)
			$SQL .= " AND (mrbtaskmaster.PRE!='Y')";
		if (USE_AWL)
			$SQL .= " AND (mrbtaskmaster.AWL!='Y')";
		if ((! TLM_INCLUDE_CMR) && ($location_type != 'CMR'))
			$SQL .= " AND (mrbtaskmaster.CMR!='Y')";
		$SQL .= " AND (workcardmaster.CardStatus='Active'))";
		$q->query($DB, $SQL);

		$SQL = "INSERT INTO TLMtemp (MRBTask,InspectionType,MRBTaskDesc,MRBThresholdValue,MRBThresholdUnits,MRBRepeatValue,MRBRepeatUnits,ThresholdValue,ThresholdUnits,RepeatValue,RepeatUnits,";
		if (USE_AWL)                                                                      $SQL .= "AWL,";                                                               if (USE_PRE)                                                                      $SQL .= "PRE,";
		$SQL .= "CMR,LocationType,FCA,AAP,SSI,ETOPS,AD,LIFE,Notes,Zone,ZoneDesc) SELECT DISTINCT mrbtaskmaster.MRBTask,mrbtaskmaster.InspectionType,mrbtaskmaster.MRBTaskDesc,mrbtaskmaster.MRBThresholdValue,mrbtaskmaster.MRBThresholdUnits,mrbtaskmaster.MRBRepeatValue,mrbtaskmaster.MRBRepeatUnits,mrbtaskmaster.ThresholdValue,mrbtaskmaster.ThresholdUnits,mrbtaskmaster.RepeatValue,mrbtaskmaster.RepeatUnits,";
		if (USE_AWL)
			$SQL .= "mrbtaskmaster.AWL,";
		if (USE_PRE)
			$SQL .= "mrbtaskmaster.PRE,";
		$SQL .= "mrbtaskmaster.CMR,mrbtaskmaster.LocationType,mrbtaskmaster.FCA,mrbtaskmaster.AAP,mrbtaskmaster.SSI,mrbtaskmaster.ETOPS,mrbtaskmaster.AD,mrbtaskmaster.LIFE,mrbtaskmaster.Notes, mrbtask2zone.Zone, zonemaster.ZoneDesc FROM mrbtaskmaster";
		$SQL .= " LEFT JOIN workcard2mrbtask ON (mrbtaskmaster.MRBTask = workcard2mrbtask.MRBTask)";
		$SQL .= " LEFT JOIN mrbtask2zone ON (mrbtaskmaster.MRBTask = mrbtask2zone.MRBTask)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcard2mrbtask.WorkCardNumber = workcardmaster.WorkCardNumber)";
		$SQL .= " LEFT JOIN zonemaster ON (mrbtask2zone.Zone = zonemaster.Zone)";
		$SQL .= " WHERE ((workcard2mrbtask.MRBTask IS NULL)";
		$SQL .= " OR (workcardmaster.CardStatus != 'Active'))";
		$SQL .= " AND ((mrbtaskmaster.LocationType='" . $location_type . "')";
		if (USE_PRE)
			$SQL .= " AND (mrbtaskmaster.PRE!='Y')";
		if (USE_AWL)
			$SQL .= " AND (mrbtaskmaster.AWL!='Y')";
		if ((! TLM_INCLUDE_CMR) && ($location_type != 'CMR'))
			$SQL .= " AND (mrbtaskmaster.CMR!='Y')";
		$SQL .= ")";
		$q->query($DB, $SQL);

		$SQL = " SELECT MRBTask, COUNT(*) as mrbcount FROM TLMtemp GROUP BY MRBTask HAVING (mrbcount > 1)";
		$q->query($DB, $SQL);
		$SQL = "DELETE FROM TLMtemp WHERE (MRBTask IS NULL AND WorkCardNumber IS NULL)";
		while ($q->getrow())
			$SQL .= " OR (WorkCardNumber='' AND MRBTask='" . addslashes($q->field("MRBTask")) . "')";
		$q->query($DB, $SQL);

		$SQL = "SELECT * FROM TLMtemp";
		$SQL .= " ORDER BY Zone, MRBTask";
	}

	if ($location_type == 'AWL') { // Special SQL for AWL case (not based on LocationType but rather the AWL boolean)
		$SQL = "DROP TABLE IF EXISTS TLMtemp";
		$q->query($DB, $SQL);

		$SQL = "CREATE TEMPORARY TABLE TLMtemp SELECT workcard2mrbtask.WorkCardNumber, mrbtaskmaster.* FROM workcard2mrbtask";
		$SQL .= " LEFT JOIN mrbtaskmaster USING (MRBTask)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcard2mrbtask.WorkCardNumber = workcardmaster.WorkCardNumber)";
		$SQL .= " WHERE ((mrbtaskmaster.AWL='Y') AND (mrbtaskmaster.PRE!='Y')";
		if ((! TLM_INCLUDE_CMR) && ($location_type != 'CMR'))
			$SQL .= " AND (mrbtaskmaster.CMR!='Y')";
		$SQL .= " AND (workcardmaster.CardStatus='Active'))";
		$q->query($DB, $SQL);

		$SQL = "INSERT INTO TLMtemp (MRBTask,InspectionType,MRBTaskDesc,MRBThresholdValue,MRBThresholdUnits,MRBRepeatValue,MRBRepeatUnits,ThresholdValue,ThresholdUnits,RepeatValue,RepeatUnits,AWL,PRE,CMR,LocationType,FCA,AAP,SSI,ETOPS,AD,LIFE,Notes) SELECT DISTINCT mrbtaskmaster.MRBTask,mrbtaskmaster.InspectionType,mrbtaskmaster.MRBTaskDesc,mrbtaskmaster.MRBThresholdValue,mrbtaskmaster.MRBThresholdUnits,mrbtaskmaster.MRBRepeatValue,mrbtaskmaster.MRBRepeatUnits,mrbtaskmaster.ThresholdValue,mrbtaskmaster.ThresholdUnits,mrbtaskmaster.RepeatValue,mrbtaskmaster.RepeatUnits,mrbtaskmaster.AWL,mrbtaskmaster.PRE,mrbtaskmaster.CMR,mrbtaskmaster.LocationType,mrbtaskmaster.FCA,mrbtaskmaster.AAP,mrbtaskmaster.SSI,mrbtaskmaster.ETOPS,mrbtaskmaster.AD,mrbtaskmaster.LIFE,mrbtaskmaster.Notes FROM mrbtaskmaster";
		$SQL .= " LEFT JOIN workcard2mrbtask ON (mrbtaskmaster.MRBTask = workcard2mrbtask.MRBTask)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcardmaster.WorkCardNumber = workcard2mrbtask.WorkCardNumber)";
		$SQL .= " WHERE ((workcard2mrbtask.MRBTask IS NULL)";
		$SQL .= " OR (workcardmaster.CardStatus != 'Active'))";
		if (USE_AWL)
			$SQL .= " AND (mrbtaskmaster.AWL='Y')";
		if (USE_PRE)
			$SQL .= " AND (mrbtaskmaster.PRE!='Y')";
		if ((! TLM_INCLUDE_CMR) && ($location_type != 'CMR'))
			$SQL .= " AND (mrbtaskmaster.CMR!='Y')";
		$q->query($DB, $SQL);

		$SQL = " SELECT MRBTask, COUNT(*) as mrbcount FROM TLMtemp GROUP BY MRBTask HAVING (mrbcount > 1)";
		$q->query($DB, $SQL);
		$SQL = "DELETE FROM TLMtemp WHERE (MRBTask IS NULL AND WorkCardNumber IS NULL)";
		while ($q->getrow())
			$SQL .= " OR (WorkCardNumber='' AND MRBTask='" . addslashes($q->field("MRBTask")) . "')";
		$q->query($DB, $SQL);

		$SQL = "SELECT * FROM TLMtemp";
		$SQL .= " ORDER BY MRBTask, WorkCardNumber";
	}
	else if ($location_type == 'CMR') { // Special SQL for CMR case (not based on LocationType but rather the CMR boolean)
		$SQL = "DROP TABLE IF EXISTS TLMtemp";
		$q->query($DB, $SQL);

		$SQL = "CREATE TEMPORARY TABLE TLMtemp SELECT workcard2mrbtask.WorkCardNumber, mrbtaskmaster.* FROM workcard2mrbtask";
		$SQL .= " LEFT JOIN mrbtaskmaster USING (MRBTask)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcard2mrbtask.WorkCardNumber = workcardmaster.WorkCardNumber)";
		$SQL .= " WHERE (mrbtaskmaster.CMR='Y')";
		if (USE_AWL)
			$SQL .= " AND ((mrbtaskmaster.AWL!='Y')";
		if (USE_PRE)
			$SQL .= " AND (mrbtaskmaster.PRE!='Y')";
		$SQL .= " AND (workcardmaster.CardStatus='Active'))";
		$q->query($DB, $SQL);

		$SQL = "INSERT INTO TLMtemp (MRBTask,InspectionType,MRBTaskDesc,MRBThresholdValue,MRBThresholdUnits,MRBRepeatValue,MRBRepeatUnits,ThresholdValue,ThresholdUnits,RepeatValue,RepeatUnits,AWL,PRE,CMR,LocationType,FCA,AAP,SSI,ETOPS,AD,LIFE,Notes) SELECT DISTINCT mrbtaskmaster.MRBTask,mrbtaskmaster.InspectionType,mrbtaskmaster.MRBTaskDesc,mrbtaskmaster.MRBThresholdValue,mrbtaskmaster.MRBThresholdUnits,mrbtaskmaster.MRBRepeatValue,mrbtaskmaster.MRBRepeatUnits,mrbtaskmaster.ThresholdValue,mrbtaskmaster.ThresholdUnits,mrbtaskmaster.RepeatValue,mrbtaskmaster.RepeatUnits,mrbtaskmaster.AWL,mrbtaskmaster.PRE,mrbtaskmaster.CMR,mrbtaskmaster.LocationType,mrbtaskmaster.FCA,mrbtaskmaster.AAP,mrbtaskmaster.SSI,mrbtaskmaster.ETOPS,mrbtaskmaster.AD,mrbtaskmaster.LIFE,mrbtaskmaster.Notes FROM mrbtaskmaster";
		$SQL .= " LEFT JOIN workcard2mrbtask ON (mrbtaskmaster.MRBTask = workcard2mrbtask.MRBTask)";
		$SQL .= " LEFT JOIN workcardmaster ON (workcardmaster.WorkCardNumber = workcard2mrbtask.WorkCardNumber)";
		$SQL .= " WHERE ((workcard2mrbtask.MRBTask IS NULL)";
		$SQL .= " OR (workcardmaster.CardStatus != 'Active'))";
		if (USE_AWL)
			$SQL .= " AND (mrbtaskmaster.AWL!='Y')";
		if (USE_PRE)
			$SQL .= " AND (mrbtaskmaster.PRE!='Y')";
		$SQL .= " AND (mrbtaskmaster.CMR='Y')";
		$q->query($DB, $SQL);

		$SQL = " SELECT MRBTask, COUNT(*) as mrbcount FROM TLMtemp GROUP BY MRBTask HAVING (mrbcount > 1)";
		$q->query($DB, $SQL);
		$SQL = "DELETE FROM TLMtemp WHERE (MRBTask IS NULL AND WorkCardNumber IS NULL)";
		while ($q->getrow())
			$SQL .= " OR (WorkCardNumber='' AND MRBTask='" . addslashes($q->field("MRBTask")) . "')";
		$q->query($DB, $SQL);

		$SQL = "SELECT * FROM TLMtemp";
		$SQL .= " ORDER BY MRBTask, WorkCardNumber";
	}

	TLMHead($long_company_name . " - " . $ac_type . "<br><font size='-1'>" . gettext("MAINTENANCE TIME LIMITS"), $report_name, '', TLM_DATE);

	$q->query($DB, $SQL);

	$lastChapter = '';
	$lastSection = '';

	while ($q->getrow()) {

		if ($format == 'ATA') { // ATA Format
    	$atachapter = getChapter($q->field("MRBTask"));
    	if ($atachapter != $lastChapter) {
				ATA_SectionHead($atachapter, $atasection, 'Chapter');
			}
		}
		else if ($format == 'ZONE') { // Zone Format
    	$zone = $q->field("Zone");
    	$zoneDesc = $q->field("ZoneDesc");
	
    	if ($zone != $lastZone) {
        	//print out zone line
        	Zone_SectionHead($zone, $zoneDesc);
    	}
		}

    //Find what Inspection Packages this is associated with for the Sched. Interval
    $SQL = "SELECT DISTINCT InspectionPackage FROM workcard2inspectionpackage";
    $SQL .= " WHERE WorkCardNumber='" . $q->field("WorkCardNumber") . "'";
    $SQL .= " ORDER BY LENGTH(InspectionPackage), InspectionPackage;";
    $inspkgs = fillLabel("SchldIntLabel", "InspectionPackage", $SQL);

		if (TLM_DISPLAY_MPD) {
			//Now find what Manuf Planning Doc this is associated with
			$SQL = "SELECT DISTINCT workcard2mpd.MPDNumber FROM workcard2mpd";
			$SQL .= " INNER JOIN MRBtemp USING (WorkCardNumber)";
			$SQL .= " ORDER BY workcard2mpd.MPDNumber;";
			$PDs = fillLabel("ReferenceNoLabel", "MPDNumber", $SQL);
		}

    // TIME TO SPIT OUT THE LINE
    $CMR = ''; $ETOPS = ''; $AD = ''; $FCA = ''; $AAP = ''; $SSI = ''; $LIFE = ''; $ELEC = ''; $HYD = '';

		if ($q->field("ELEC") != '------')
			$ELEC = ' ' . $q->field("ELEC") . ' ';
		if ($q->field("HYD") != '------')
			$HYD = ' ' . $q->field("HYD") . ' ';

		if ($q->field("CMR") == 'Y')
			$CMR = ' CMR ';
    if ($q->field("ETOPS") == 'Y')
			$ETOPS = ' ETOPS ';
		if ($q->field("AD") == 'Y')
			$AD = ' AD ';
		if ($q->field("FCA") == 'Y')
			$FCA = ' FCA ';
		if ($q->field("AAP") == 'Y')
			$AAP = ' AAP ';
		if ($q->field("SSI") == 'Y')
			$SSI = ' SSI ';
		if ($q->field("LIFE") == 'Y')
			$LIFE = ' LIFE ';

		if ((($atasection == $lastSection) && ($atachapter == $lastChapter)) || ($format == 'NONE'))
			echo("<!-- BLOCK -->\n");
    ?>

    <tr>
        <td class="MRBATAItem" width="9%"><p><? echo($q->field("MRBTask")); ?>&nbsp;</p></td>
				<? if (TLM_DISPLAY_MPD) { ?>
        	<td class="MRBATAItem" width="9%"><p><? echo($PDs); ?>&nbsp;</p></td>
				<? } ?>
        <td class="MRBATAItem" width="29%"><p><? echo($q->field("MRBTaskDesc")); ?>&nbsp;</p></td>
        <td class="MRBATAItem" width="4%"><p><? echo($q->field("InspectionType")); ?>&nbsp;</p></td>
        <td class="MRBATAItem" width="6%"><p><? echo($q->field("ThresholdValue") . " " . $q->field("ThresholdUnits")); ?>&nbsp;</p></td>
        <td class="MRBATAItem" width="6%"><p><? echo($q->field("RepeatValue") . " " . $q->field("RepeatUnits")); ?>&nbsp;</p></td>
        <td class="MRBATAItem" width="4%"><p><? echo($CMR . $ETOPS . $AD . $FCA . $AAP . $SSI . $LIFE . $ELEC . $HYD); ?>&nbsp;</p></td>
        <td class="MRBATAItem" width="9%"><p><? echo($q->field("WorkCardNumber")); ?>&nbsp;</p></td>
        <td class="MRBATAItem" width="9%"><p><? echo($inspkgs); ?>&nbsp;</p></td>
        <td class="MRBATAItem"><p><? echo($q->field("Notes")); ?>&nbsp;</p></td>
    </tr>

    <?

		if ($format == 'ATA') { // ATA Format
			$lastChapter = $atachapter;
			$lastSection = $atasection;
		}
		else if ($format == 'ZONE') { // Zone Format
			$lastZone = $zone;
		}
	}

	TLMFoot();
	base_footer();

}

function TLMHead($manual, $chaptername, $ataname, $thedate, $showth = true) {
	?>
	<div repeat=0>
	<table width="98%" border="0" cellpadding="2" cellspacing="0">
		<tr>
			<td width="79%" valign="top" class="MRBATATitle"><? echo($manual); ?></td>
			<td width="19%" valign="top" align="right">
				<div class="MRBATAChapterName"><? echo($chaptername); ?></div><br>
				<div class="MRBATAATAName"><? echo($ataname); ?></div><br>
				<div class="MRBATADate"><? echo($thedate); ?></div>
			</td>
		</tr>
	</table>

	<hr>
	</div>

	<? if ($showth) { ?>
	<table width="98%" border="1" cellpadding="2" cellspacing="0">
		<tr repeat=1>
			<th width="9%" class="MRBATAHeader"><? echo(gettext("MRB<br>No.")); ?></th>
			<? if (TLM_DISPLAY_MPD) { ?>
				<th width="9%" class="MRBATAHeader"><? echo(gettext("Reference<br>No.")); ?></th>
			<? } ?>
			<th width="29%" class="MRBATAHeader"><? echo(gettext("Task Description")); ?></th>
			<th width="4%" class="MRBATAHeader"><? echo(gettext("Task")); ?></th>
			<th width="6%" class="MRBATAHeader"><? echo(gettext("Threshold")); ?></th>
			<th width="6%" class="MRBATAHeader"><? echo(gettext("Repeat")); ?></th>
			<th width="4%" class="MRBATAHeader"><? echo(gettext("ETOPS/<br>CMR/AD")); ?></th>
			<th width="9%" class="MRBATAHeader"><? echo(gettext("Card No.")); ?></th>
			<th width="9%" class="MRBATAHeader"><? echo(gettext("Scheduled<br>Interval")); ?></th>
			<th class="MRBATAHeader"><? echo(gettext("Special<br>Instructions")); ?></th>
		</tr>
	<? }
}

function ATA_SectionHead($atachap, $atasec, $type) {
	if ($type == 'Section') {
		// only the section changed
		$label = FormatATA($atachap, $atasec, "Section");
	}
	else {
		// both section and chapter changed
		$label = FormatATA($atachap, $atasec, "Chapter");
	}

	?> 
	<!-- BLOCK 2 -->
	<tr>
		<td colspan="<? echo(TLM_NUM_COLS); ?>" class="MRBATASectionHeader"><? echo($label); ?></td>
	</tr>
	<?
}

function Zone_SectionHead($zone, $zoneDesc) {
	if (empty($zoneDesc)) {
		if ($zone == 0) // no zone
			$label = "N/A";
		else
			$label = $zone;
	}
	else {
		$label = $zoneDesc;
	}

	?>
	<!-- BLOCK 2 -->
	<tr>
		<td colspan="<? echo(TLM_NUM_COLS); ?>" class="MRBATASectionHeader"><? echo($label); ?></td>
	</tr>
	<?
}

function TLMFoot() {
	echo ("</table>\n");
}
?>
