<?php

$LOGGED_IN=false;
//clear it out in case someone sets it in the URL or something
unset($LOGGED_IN);

function user_isloggedin() {
	global $user_name,$id_hash,$user_class,$hidden_hash_var,$LOGGED_IN;
	//have we already run the hash checks? 
	//If so, return the pre-set var
	if (isset($LOGGED_IN)) {
		return $LOGGED_IN;
	}
	if ($user_name && $id_hash) {
		$hash=md5($user_name.$user_class.$hidden_hash_var);
		if ($hash == $id_hash) {
			$LOGGED_IN=true;
			return true;
		} else {
			$LOGGED_IN=false;
			return false;
		}
	} else {
		$LOGGED_IN=false;
		return false;
	}
}

function user_login($user_name,$password) {
	global $feedback, $q, $DB;
	if (!$user_name || !$password) {
		$feedback .=  ' ERROR - Missing user name or password ';
		return false;
	} else {
		$user_name=strtolower($user_name);
		$password=strtolower($password);
		$sql="SELECT * FROM user WHERE user_name='$user_name' AND password='". md5($password) ."'";
		$result=$q->query($DB, $sql);
		$q->getrow();
		if (!$result || $q->numrows() < 1){
			$feedback .=  ' ERROR - User not found or password incorrect ';
			return false;
		} else {
			if ($q->field("is_confirmed") == '1') {
				user_set_tokens($user_name, $q->field("user_class"), $q->field("flags"));
				$feedback .=  ' SUCCESS - You Are Now Logged In ';
				return true;
			} else {
				$feedback .=  ' ERROR - You haven\'t Confirmed Your Account Yet ';
				return false;
			}
		}
	}
}

function user_logout() {
	setcookie('user_name','',0,'/','',0);
	setcookie('id_hash','',0,'/','',0);
	setcookie('user_class','',0,'/','',0);
}

function user_set_tokens($user_name_in, $user_class_in, $user_flags_in) {
	global $feedback,$hidden_hash_var,$user_name,$user_class,$id_hash,$user_flags;
	if (empty($user_name_in)) {
		$feedback .=  ' ERROR - User Name Missing When Setting Tokens ';
		return false;
	}
	$user_name=strtolower($user_name_in);
	$user_class=strtolower($user_class_in);
	$id_hash= md5($user_name.$user_class.$hidden_hash_var);

	setcookie('user_name',$user_name,0,'/','',0);
	setcookie('id_hash',$id_hash,0,'/','',0);
	setcookie('user_class',$user_class,0,'/','',0);
	$user_flags = preg_split('//', $user_flags_in, -1, PREG_SPLIT_NO_EMPTY);
}

function user_confirm($hash,$email) {
	/*
		Call this function on the user confirmation page,
		which they arrive at when the click the link in the
		account confirmation email
	*/

	global $feedback,$hidden_hash_var, $q, $DB;

	//verify that they didn't tamper with the email address
	$new_hash=md5($email.$hidden_hash_var);
	if ($new_hash && ($new_hash==$hash)) {
		//find this record in the db
		$sql="SELECT * FROM user WHERE confirm_hash='$hash'";
		$result=$q->query($DB, $sql);
		if (!$result || $q->numrows() < 1) {
			$feedback .= ' ERROR - Hash Not Found ';
			return false;
		} else {
			$q->getrow();
			//confirm the email and set account to active
			$feedback .= ' User Account Updated - You May Log In Now ';
			user_set_tokens($q->field("user_name"), $q->field("user_class"), $q->field("flags"));
			$sql="UPDATE user SET email='$email',is_confirmed='1' WHERE confirm_hash='$hash'";
			$result=$q->query($DB, $sql);
			return true;
		}
	} else {
		$feedback .= ' HASH INVALID - UPDATE FAILED ';
		return false;
	}
}

function user_change_password ($new_password1,$new_password2,$change_user_name,$old_password) {
	global $feedback, $q, $DB;
	//new passwords present and match?
	if ($new_password1 && ($new_password1==$new_password2)) {
		//is this password long enough?
		if (account_pwvalid($new_password1)) {
			//all vars are present?
			if ($change_user_name && $old_password) {
				//lower case everything
				$change_user_name=strtolower($change_user_name);
				$old_password=strtolower($old_password);
				$new_password1=strtolower($new_password1);
				$sql="SELECT * FROM user WHERE user_name='$change_user_name' AND password='". md5($old_password) ."'";
				$result=$q->query($DB, $sql);
				if (!$result || $q->numrows() < 1) {
					$feedback .= ' User not found or bad password '. $q->error();
					return false;
				} else {
					$sql="UPDATE user SET password='". md5($new_password1). "' ".
						"WHERE user_name='$change_user_name' AND password='". md5($old_password). "'";
					if (! $q->query($DB, $sql)) {
						$feedback .= ' NOTHING Changed '. $q->error();
						return false;
					} else {
						$feedback .= ' Password Changed ';
						return true;
					}
				}
			} else {
				$feedback .= ' Must Provide User Name And Old Password ';
				return false;
			}
		} else {
			$feedback .= ' New Passwords Doesn\'t Meet Criteria ';
			return false;
		}
	} else {
		return false;
		$feedback .= ' New Passwords Must Match ';
	}
}

function user_lost_password ($email,$user_name) {
	global $feedback,$hidden_hash_var, $q, $DB;
	if ($email && $user_name) {
		$user_name=strtolower($user_name);
		$sql="SELECT * FROM user WHERE user_name='$user_name' AND email='$email'";
		$result=$q->query($DB, $sql);
		if (!$result || $q->numrows() < 1) {
			//no matching user found
			$feedback .= ' ERROR - Incorrect User Name Or Email Address ';
			return false;
		} else {
			//create a secure, new password
			$new_pass=strtolower(substr(md5(time().$user_name.$hidden_hash_var),1,14));

			//update the database to include the new password
			$sql="UPDATE user SET password='". md5($new_pass) ."' WHERE user_name='$user_name'";
			$result=$q->query($DB, $sql);

			//send a simple email with the new password
			mail ($email,'Password Reset','Your Password '.
				'has been reset to: '.$new_pass,'From: noreply@cavokintl.com');
			$feedback .= ' Your new password has been emailed to you. ';
			return true;
		}
	} else {
		$feedback .= ' ERROR - User Name and Email Address Are Required ';
		return false;
	}
}

function user_change_email ($password1,$new_email,$user_name) {
	global $feedback,$hidden_hash_var, $q, $DB;
	if (validate_email($new_email)) {
		$hash=md5($new_email.$hidden_hash_var);
		//change the confirm hash in the db but not the email - 
		//send out a new confirm email with a new hash
		$user_name=strtolower($user_name);
		$password1=strtolower($password1);
		$sql="SELECT * FROM user WHERE user_name='$user_name' AND password='". md5($password1) ."'";
                $result=$q->query($DB, $sql); 
                if (!$result || $q->numrows() < 1) {
                	$feedback .= ' User not found or bad password '. $q->error();
                	return false;
                } else {
			$sql="UPDATE user SET confirm_hash='$hash' WHERE user_name='$user_name' AND password='". md5($password1) ."'";
			if (! $q->query($DB, $sql)) {
				$feedback .= ' ERROR - Email Not Changed ';
				return false;
			} else {
				$feedback .= ' Confirmation Sent ';
				user_send_confirm_email($new_email,$hash);
				return true;
			}
		}
	} else {
		$feedback .= ' New Email Address Appears Invalid ';
		return false;
	}
}

function user_send_confirm_email($email,$hash) {
	global $website_address;
	/*
		Used in the initial registration function
		as well as the change email address function
	*/

	$message = "Thank You For Registering at COMMAND".
		"\nSimply follow this link to confirm your registration: ".
		"\n\nhttp://" . $website_address . "/confirm.php?hash=$hash&email=". urlencode($email).
		"\n\nOnce you confirm, you can use the services on COMMAND.";
	mail ($email,'COMMAND Registration Confirmation',$message,'From: noreply@cavokintl.com');
}

function user_register($user_name,$password1,$password2,$email,$real_name,$company,$base,$title,$phone,$empid) {
	global $feedback,$hidden_hash_var, $q, $DB;
	//all vars present and passwords match?
	if ($user_name && $password1 && $password1==$password2 && $email && validate_email($email)) {
		//password and name are valid?
		if (account_namevalid($user_name) && account_pwvalid($password1)) {
			$user_name=strtolower($user_name);
			$password1=strtolower($password1);

			//does the name exist in the database?
			$sql="SELECT * FROM user WHERE user_name='$user_name'";
			$result=$q->query($DB, $sql);
			if ($result && $q->numrows() > 0) {
				$feedback .=  ' ERROR - USER NAME EXISTS ';
				return false;
			} else {
				//create a new hash to insert into the db and the confirmation email
				$hash=md5($email.$hidden_hash_var);
				$SQL = "INSERT INTO user (user_name,real_name,user_class,password,email,remote_addr";
				$SQL .= ",confirm_hash,is_confirmed,Company,Base,Title,PhoneNumber,EmployeeID)";
				$SQL .= " VALUES ('" . addslashes($user_name) . "','" . addslashes($real_name) . "'";
				$SQL .= ",'0','". md5($password1) . "','" . addslashes($email) . "','" . addslashes($GLOBALS[REMOTE_ADDR]) . "'";
				$SQL .= ",'" . addslashes($hash) . "','0'" . ",'" . addslashes($company) . "','" . addslashes($base) . "'";
				$SQL .= ",'" . addslashes($title) . "','" . addslashes($phone) . "','" . addslashes($empid) . "')";
				$result=$q->query($DB, $SQL);
				if (!$result) {
					$feedback .= ' ERROR - '. $q->error();
					return false;
				} else {
					//send the confirm email
					user_send_confirm_email($email,$hash);
					$feedback .= ' Successfully Registered. You Should Have a Confirmation Email Waiting ';
					return true;
				}
			}
		} else {
			$feedback .=  ' Account Name or Password Invalid ';
			return false;
		}
	} else {
		$feedback .=  ' ERROR - Must Fill In User Name, Matching Passwords, And Provide Valid Email Address ';
		return false;
	}
}

function user_getid() {
	global $G_USER_RESULT, $q, $DB;
	//see if we have already fetched this user from the db, if not, fetch it
	if (!$G_USER_RESULT) {
		$G_USER_RESULT=$q->query($DB, "SELECT * FROM user WHERE user_name='" . user_getname() . "'");
	}
	if ($G_USER_RESULT && $q->numrows() > 0) {
		$q->getrow();
		return $q->field("user_id");
	} else {
		return false;
	}
}

function user_getrealname() {
	global $G_USER_RESULT, $q, $DB;
	//see if we have already fetched this user from the db, if not, fetch it
	if (!$G_USER_RESULT) {
		$G_USER_RESULT=$q->query($DB, "SELECT * FROM user WHERE user_name='" . user_getname() . "'");
	}
	if ($G_USER_RESULT && $q->numrows() > 0) {
		$q->getrow();
		return $q->field("real_name");
	} else {
		return false;
	}
}

function user_getemail() {
	global $G_USER_RESULT, $q, $DB;
	//see if we have already fetched this user from the db, if not, fetch it
	if (!$G_USER_RESULT) {
		$G_USER_RESULT=$q->query($DB, "SELECT * FROM user WHERE user_name='" . user_getname() . "'");
	}
	if ($G_USER_RESULT && $q->numrows() > 0) {
		$q->getrow();
		return $q->field("email");
	} else {
		return false;
	}
}

function user_getclass() {
	global $G_USER_RESULT, $q, $DB;
	//see if we have already fetched this user from the db, if not, fetch it
	if (!$G_USER_RESULT) {
		$G_USER_RESULT=$q->query($DB, "SELECT * FROM user WHERE user_name='" . user_getname() . "'");
	}
	if ($G_USER_RESULT && $q->numrows() > 0) {
		$q->getrow();
		return $q->field("user_class");
	} else {
		return false;
	}
}

function user_getname() {
	if (user_isloggedin()) {
		return $GLOBALS['user_name'];
	} else {
		//look up the user some day when we need it
		return ' ERROR - Not Logged In ';
	}
}

function account_pwvalid($pw) {
	global $feedback;
	if (strlen($pw) < 4) {
		$feedback .= " Password must be at least 4 characters. ";
		return false;
	}
	return true;
}

function account_namevalid($name) {
	global $feedback;
	// no spaces
	if (strrpos($name,' ') > 0) {
		$feedback .= " There cannot be any spaces in the login name. ";
		return false;
	}

	// must have at least one character
	if (strspn($name,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ") == 0) {
		$feedback .= "There must be at least one character.";
		return false;
	}

	// must contain all legal characters
	if (strspn($name,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_")
		!= strlen($name)) {
		$feedback .= " Illegal character in name. ";
		return false;
	}

	// min and max length
	if (strlen($name) < 3) {
		$feedback .= " Name is too short. It must be at least 5 characters. ";
		return false;
	}
	if (strlen($name) > 15) {
		$feedback .= "Name is too long. It must be less than 15 characters.";
		return false;
	}

	// illegal names
	if (eregi("^((root)|(bin)|(daemon)|(adm)|(lp)|(sync)|(shutdown)|(halt)|(mail)|(news)"
		. "|(uucp)|(operator)|(games)|(mysql)|(httpd)|(nobody)|(dummy)"
		. "|(www)|(cvs)|(shell)|(ftp)|(irc)|(debian)|(ns)|(download))$",$name)) {
		$feedback .= "Name is reserved.";
		return 0;
	}
	if (eregi("^(anoncvs_)",$name)) {
		$feedback .= "Name is reserved for CVS.";
		return false;
	}

	return true;
}

function validate_email ($address) {
	return (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'. '@'. '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.' . '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $address));
}

function check_userflags($flag, $yn = false) {
	global $user_flags;

	if ((count($user_flags) > $flag) && ($user_flags[$flag] == 1)) {
		if ($yn)
			return 'Y';
		else
			return true;
	}
	else {
		if ($yn)
			return 'N';
		else
			return false;
	}
}

?>
